#pragma once

#include "Stdafx.h"

#include <vector>
using std::vector;


struct SHour
{
	int nX;
	int nY;

	char cDay; //sun, mon,..
	char cHour;
	char cState;

	enum
	{
		STATE_FREE,
		STATE_HOVERED,
		STATE_SELECTED
	};

	SHour()
	{
		cState = STATE_FREE;
	}
};


typedef vector<SHour> VECHOURS;
typedef vector<std::pair<char, char>> VECSELHOURS;

class CSchedulerCtrl
{
protected:

	VECHOURS	m_vecHours;

	int			m_nCellWidth;
	int			m_nCellHeight;
	RECT		m_rc;

	COLORREF	m_refColor;
	COLORREF	m_refColorHover;
	COLORREF	m_refColorSel;
	COLORREF	m_refColorBorder;

	SHour*		m_pHoveredHour;

	HFONT		m_hFontDays;
	HFONT		m_hFontSelHour;
	HBRUSH		m_hBrushBk;


public:

	CSchedulerCtrl(void);
	virtual ~CSchedulerCtrl(void);

	bool Init(int nX, int nY, int nCellWidth = 18, int nCellHeight = 18);
	void Paint(HDC hDC);
	void PaintCell(HDC hDC, SHour& myHour);
	void PaintHourTime(HDC, int nX, SHour* pHour);
	void OnMouseMove(HDC hDC, int nX, int nY, RECT* prcChanged, RECT* prcChanged2);
	void OnMouseLClick(HDC hDC, int nX, int nY, RECT* prcChanged);

	void SetColor(COLORREF& refClr);
	void SetColorHover(COLORREF& refClr);
	void SetColorSel(COLORREF& refClr);
	void SetColorBorder(COLORREF& refClr);
	void SetCellDimensions(int nCX, int nCY);

	void GetSelectedHours(VECSELHOURS& vecSelHours);

};
